byte printer = 0;
chan mayIPrint = [0] of { bool };

proctype computer(byte id) {
  do 
    :: mayIPrint ? 1 ;
       printer++;
       printf("Computer %d is printing \n", id);
       printer--;
       mayIPrint ! 1 ;
  od
}

// Alternative solution, allowing one computer to print multiple times in a row:

proctype pc(byte id) {
  do 
    :: mayIPrint ? 1 ;
       printer++;
       printf("PC %d is printing \n", id);
       printer--;
       mayIPrint ! 0 ;
  od
}

proctype mediator() {
  do 
    :: mayIPrint ? 0 ;
       mayIPrint ! 1 
  od
}

init {
  atomic {
    run computer(0);
    run computer(1);
   // run pc(0);
   // run pc(1);
   // run mediator();
  }
  mayIPrint ! 1;
}
